package com.maroontress.coverture;

import java.util.concurrent.Callable;
import java.util.concurrent.CompletionService;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.ExecutorCompletionService;
import java.util.concurrent.Executors;
import java.util.concurrent.Future;

/**
   ӥǤ

   @param <T> ͤΥ饹
*/
public final class DeliveryService<T> {

    /** ͤθĿǤ */
    private int taskCount;

    /** ͤƱΥ塼Ǥ */
    private CompletionService<T> service;

    /**
       åɥסΥåɿꤷơ󥹥󥹤ޤ

       @param threads åɿ
    */
    public DeliveryService(final int threads) {
	service = new ExecutorCompletionService<T>(
	    Executors.newFixedThreadPool(threads));
	taskCount = 0;
    }

    /**
       ֤ͤ¹ѥޤ

       @param callable ֤ͤ¹ѥ
    */
    public void submit(final Callable<T> callable) {
	++taskCount;
	service.submit(callable);
    }

    /**
       ӥ̤ꥹʤΤޤ٤ƤΥ
       ̤ΤǤޤǥ֥åޤ

       @param listener ꥹ
       @throws ExecutionException åɤ㳰򥹥
    */
    public void deliver(final DeliveryListener<T> listener)
	throws ExecutionException {
 	try {
	    while (taskCount > 0) {
		Future<T> future = service.take();
		T instance = future.get();
		if (instance == null) {
		    continue;
		}
		listener.deliver(instance);
		--taskCount;
	    }
	} catch (InterruptedException e) {
	    throw new RuntimeException("internal error.", e);
	}
    }
}
