package com.maroontress.coverture;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.Collection;
import java.util.HashMap;

/**
   ҤȤĤgcnoե뤬Ȥ륽եΥꥹȤǤ
*/
public final class SourceList {

    /** ѡȤѴ뤿ηǤ */
    private static final double PERCENT = 100;

    /** եΥѥȥΥޥåפǤ */
    private HashMap<String, Source> map;

    /**
       ꥹȤޤ
    */
    public SourceList() {
	map = new HashMap<String, Source>();
    }

    /**
       եΥѥб륽ޤ

       @param sourceFile եΥѥ
       @return 
    */
    public Source getSource(final String sourceFile) {
	Source source = map.get(sourceFile);
	if (source == null) {
	    source = new Source(sourceFile);
	    map.put(sourceFile, source);
	}
	return source;
    }

    /**
       ٤ƤΥХåեޤ

       @param origin gcnoեΥꥸ
       @param runs ץμ¹Բ
       @param programs ץο
       @param prop ϥץѥƥ
    */
    public void outputFiles(final Origin origin, final int runs,
			    final int programs, final IOProperties prop) {
	Collection<Source> all = map.values();
	for (Source s : all) {
	    try {
		s.outputFile(origin, runs, programs, prop);
	    } catch (IOException e) {
		e.printStackTrace();
	    }
	}
    }

    /**
       եΥꥹȤΥޥXMLǽϤޤ

       @param out 
    */
    public void printXML(final PrintWriter out) {
	out.printf("<sourceList>\n");
	Collection<Source> all = map.values();
	for (Source s : all) {
	    String path = s.getPath();
	    int executedLines = s.getExecutedLines();
	    int executableLines = s.getExecutableLines();
	    out.printf("<source file='%s' executableLines='%d'",
		       path, executableLines);
	    if (executableLines > 0) {
		out.printf(" executedLines='%d' rate='%.2f'",
			   executedLines,
			   PERCENT * executedLines / executableLines);
	    }
	    out.printf("/>\n");
	}
	out.printf("</sourceList>\n");
    }
}
